package com.steerinfo.baseinfo.meterbasesystemnews.controller;

import com.steerinfo.baseinfo.meterbasesystemnews.mapper.MeterBaseSystemNewsMapper;
import com.steerinfo.framework.controller.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.framework.utils.collection.ListUtils;
import com.steerinfo.baseinfo.meterbasesystemnews.model.MeterBaseSystemNews;
import com.steerinfo.baseinfo.meterbasesystemnews.service.IMeterBaseSystemNewsService;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.apache.commons.lang3.StringUtils;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.ArrayList;
import java.math.BigDecimal;

/**
 * MeterBaseSystemNews RESTful接口：
 * @author generator
 * @version 1.0-SNAPSHORT 2022-07-25 09:45
 * 类描述
 * 修订历史：
 * 日期：2022-07-25
 * 作者：generator
 * 参考：
 * 描述：MeterBaseSystemNews RESTful接口
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@RestController
@RequestMapping("/${api.version}/meterbasesystemnewss")
public class MeterBaseSystemNewsController extends BaseRESTfulController {

    @Autowired
    IMeterBaseSystemNewsService meterBaseSystemNewsService;

    @Resource
    MeterBaseSystemNewsMapper meterBaseSystemNewsMapper;

    @ApiOperation(value="获取列表", notes="分页查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterbasesystemnews:view")
    @GetMapping(value = "/")
    public RESTfulResult list(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<MeterBaseSystemNews> list = meterBaseSystemNewsService.queryForPage(parmas, pageNum, pageSize);
        return success(list);
    }

    @ApiOperation(value="获取列表", notes="分页模糊查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterbasesystemnews:view")
    @GetMapping(value = "/like/")
    public RESTfulResult listLike(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<MeterBaseSystemNews> list = meterBaseSystemNewsService.queryLikeForPage(parmas, pageNum, pageSize);
        return success(list);
    }
    
    @ApiOperation(value="创建", notes="根据MeterBaseSystemNews对象创建")
    @ApiImplicitParam(name = "meterBaseSystemNews", value = "详细实体meterBaseSystemNews", required = true, dataType = "MeterBaseSystemNews")
    //@RequiresPermissions("meterbasesystemnews:create")
    @PostMapping(value = "/")
    public RESTfulResult add(@ModelAttribute MeterBaseSystemNews model){
        MeterBaseSystemNews meterBaseSystemNews = meterBaseSystemNewsService.add(model);
        return success(meterBaseSystemNews);
    }

    @ApiOperation(value="获取详细信息", notes="根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterbasesystemnews:view")
    @GetMapping(value = "/{id}")
    public RESTfulResult get(@PathVariable String id){
        MeterBaseSystemNews meterBaseSystemNews = meterBaseSystemNewsService.getById(id);
        return success(meterBaseSystemNews);
    }

    @ApiOperation(value="更新详细信息", notes="根据url的id来指定更新对象，并根据传过来的meterBaseSystemNews信息来更新详细信息")
    @ApiImplicitParams({
        @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String"),
        @ApiImplicitParam(name = "meterBaseSystemNews", value = "详细实体meterBaseSystemNews", required = true, dataType = "MeterBaseSystemNews")
    })
    //@RequiresPermissions("meterbasesystemnews:update")
    @PutMapping(value = "/{id}", produces  = "application/json;charset=UTF-8")
    public RESTfulResult update(@PathVariable String id, @RequestBody MeterBaseSystemNews model){
        model.setId(id);
        MeterBaseSystemNews meterBaseSystemNews = meterBaseSystemNewsService.modify(model);
        return success(meterBaseSystemNews);
    }

    @ApiOperation(value="删除", notes="根据url的id来指定删除对象")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterbasesystemnews:delete")
    @DeleteMapping(value = "/{id}")//String
    public RESTfulResult delete(@PathVariable String id){
    	List<String> list = Arrays.asList(id.split(","));
    	if(ListUtils.isNotEmpty(list)) {
	    	List<String> ids = ListUtils.convertList(list);
			  meterBaseSystemNewsService.delete(ids);
    	}
      return success();
    }

    @ApiOperation(value="App登录自动生成车辆通告信息", notes="根据carNo获取MeterBaseSystemMessage生成MeterBaseSystemNews")
    @PostMapping(value = "/addNews")
    public RESTfulResult addNews(@RequestBody HashMap params) {
        RESTfulResult rm = meterBaseSystemNewsService.addNews(params);
        return rm;
    }

    @ApiOperation(value="倒序获取车辆通告信息", notes="根据carNo获取MeterBaseSystemNews")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterbasesystemnews:view")
    @GetMapping(value = "/newsListDesc/")
    public RESTfulResult newsListDesc(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<MeterBaseSystemNews> list = meterBaseSystemNewsService.newsListDesc(parmas, pageNum, pageSize);
        return success(list);
    }

    @ApiOperation(value="系统消息已读", notes="系统消息已读")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "parma", value = "HashMap", required = true, dataType = "HashMap")
    })
    @PutMapping(value = "/updateIsRead", produces  = "application/json;charset=UTF-8")
    public RESTfulResult updateIsRead(@RequestBody HashMap parma){
        try {
            if((parma.get("carNo") == null || StringUtils.isEmpty(parma.get("carNo").toString())) &&
                    (parma.get("systemMessageNo") == null || StringUtils.isEmpty(parma.get("systemMessageNo").toString()))) {
                return  failed(null, "车号和信息编号不能为空");
            }
            meterBaseSystemNewsMapper.updateIsRead(parma.get("carNo").toString() + parma.get("systemMessageNo").toString());
        }
        catch (Exception e){
            e.printStackTrace();
            return  failed(null,"操作异常，请确认");
        }
        return success();
    }
}
